//
//  UnitChipList.m
//  Awars III
//
//  Created by Killery on 2012/12/17.
//  Copyright (c) 2012年 Killery. All rights reserved.
//

#import "UnitChipList.h"

@implementation UnitChipList
- (void)dealloc
{
    [super dealloc];
}

- (NSMutableArray*)unitChipListMA{
    return unitChipListMA;
}
-(IBAction)submit:(id)sender{
    [UCLPanel close];
}

-(void)awakeFromNib{
    [unitChipListTV setTarget:self];
    [unitChipListTV setDoubleAction:@selector(doubleClickUCL:)];
    
    [attackListTV setTarget:self];
    [attackListTV setDoubleAction:@selector(doubleClickAL:)];
    
    [equipListTV setTarget:self];
    [equipListTV setDoubleAction:@selector(doubleClickEQ:)];
    
    [self addPUBEquipList];
    equipItemMA = [NSMutableArray new];
    attackListMA = [NSMutableArray new];
    damageListMA = [NSMutableArray new];
    hitListMA = [NSMutableArray new];
}
-(id)init{
    [super init];
    
    if (self) {
        UCLtime  = [NSTimer
                    scheduledTimerWithTimeInterval:0.05f
                    target:self
                    selector:@selector(EventLoopUCL:)
                    userInfo:nil
                    repeats:YES
                    ];
        [self initFileDirectory];
        [self initUnitChipList];
        [self initFileDirectoryItem];
        [self initItemList];
        [self initFileDirectoryAttack];
        UnitChipMax = (int)chipNumb/24 + 1;
    }
    
    return self;
}



NSInteger clickIndex = -1;
NSInteger clickIndexAL = -1;
NSInteger clickIndexEQ = -1;
bool InitialFlag;

-(void)EventLoopUCL:(NSTimer*)time{
    
    
    double STRfix;
    double VITfix;
    double AGIfix;
    double DEXfix;
    double MENfix;
    double INTfix;
    double LUKfix;
    
    double S, V, A, D, M, I;
    
    STRfix = (
    UC[clickIndex].eHandL.STR +
    UC[clickIndex].eHandR.STR +
    UC[clickIndex].eHead.STR +
    UC[clickIndex].eBody.STR +
    UC[clickIndex].eFoot.STR +
    UC[clickIndex].eArm.STR) +
    UC[clickIndex].STR *(
    UC[clickIndex].eHandL.pSTR + 
    UC[clickIndex].eHandR.pSTR +
    UC[clickIndex].eHead.pSTR +
    UC[clickIndex].eBody.pSTR +
    UC[clickIndex].eFoot.pSTR +
    UC[clickIndex].eArm.pSTR +
    0)/100
    ;
    
    VITfix = (
              UC[clickIndex].eHandL.VIT +
              UC[clickIndex].eHandR.VIT +
              UC[clickIndex].eHead.VIT +
              UC[clickIndex].eBody.VIT +
              UC[clickIndex].eFoot.VIT +
              UC[clickIndex].eArm.VIT) +
    UC[clickIndex].VIT *(
                         UC[clickIndex].eHandL.pVIT +
                         UC[clickIndex].eHandR.pVIT +
                         UC[clickIndex].eHead.pVIT +
                         UC[clickIndex].eBody.pVIT +
                         UC[clickIndex].eFoot.pVIT +
                         UC[clickIndex].eArm.pVIT +
                         0)/100
    ;
    AGIfix = (
              UC[clickIndex].eHandL.AGI +
              UC[clickIndex].eHandR.AGI +
              UC[clickIndex].eHead.AGI +
              UC[clickIndex].eBody.AGI +
              UC[clickIndex].eFoot.AGI +
              UC[clickIndex].eArm.AGI) +
    UC[clickIndex].AGI *(
                         UC[clickIndex].eHandL.pAGI +
                         UC[clickIndex].eHandR.pAGI +
                         UC[clickIndex].eHead.pAGI +
                         UC[clickIndex].eBody.pAGI +
                         UC[clickIndex].eFoot.pAGI +
                         UC[clickIndex].eArm.pAGI +
                         0)/100
    ;
    DEXfix = (
              UC[clickIndex].eHandL.DEX +
              UC[clickIndex].eHandR.DEX +
              UC[clickIndex].eHead.DEX +
              UC[clickIndex].eBody.DEX +
              UC[clickIndex].eFoot.DEX +
              UC[clickIndex].eArm.DEX) +
    UC[clickIndex].DEX *(
                         UC[clickIndex].eHandL.pDEX +
                         UC[clickIndex].eHandR.pDEX +
                         UC[clickIndex].eHead.pDEX +
                         UC[clickIndex].eBody.pDEX +
                         UC[clickIndex].eFoot.pDEX +
                         UC[clickIndex].eArm.pDEX +
                         0)/100
    ;
    MENfix = (
              UC[clickIndex].eHandL.MEN +
              UC[clickIndex].eHandR.MEN +
              UC[clickIndex].eHead.MEN +
              UC[clickIndex].eBody.MEN +
              UC[clickIndex].eFoot.MEN +
              UC[clickIndex].eArm.MEN) +
    UC[clickIndex].MEN *(
                         UC[clickIndex].eHandL.pMEN +
                         UC[clickIndex].eHandR.pMEN +
                         UC[clickIndex].eHead.pMEN +
                         UC[clickIndex].eBody.pMEN +
                         UC[clickIndex].eFoot.pMEN +
                         UC[clickIndex].eArm.pMEN +
                         0)/100
    ;
    INTfix = (
              UC[clickIndex].eHandL.INT +
              UC[clickIndex].eHandR.INT +
              UC[clickIndex].eHead.INT +
              UC[clickIndex].eBody.INT +
              UC[clickIndex].eFoot.INT +
              UC[clickIndex].eArm.INT) +
    UC[clickIndex].INT *(
                         UC[clickIndex].eHandL.pINT +
                         UC[clickIndex].eHandR.pINT +
                         UC[clickIndex].eHead.pINT +
                         UC[clickIndex].eBody.pINT +
                         UC[clickIndex].eFoot.pINT +
                         UC[clickIndex].eArm.pINT +
                         0)/100
    ;
    LUKfix = (
              UC[clickIndex].eHandL.LUK +
              UC[clickIndex].eHandR.LUK +
              UC[clickIndex].eHead.LUK +
              UC[clickIndex].eBody.LUK +
              UC[clickIndex].eFoot.LUK +
              UC[clickIndex].eArm.LUK) +
    UC[clickIndex].LUK *(
                         UC[clickIndex].eHandL.pLUK +
                         UC[clickIndex].eHandR.pLUK +
                         UC[clickIndex].eHead.pLUK +
                         UC[clickIndex].eBody.pLUK +
                         UC[clickIndex].eFoot.pLUK +
                         UC[clickIndex].eArm.pLUK +
                         0)/100
    ;
    
        UC[clickIndex].STR = [TFstr doubleValue];
        UC[clickIndex].VIT = [TFvit doubleValue];
        UC[clickIndex].AGI = [TFagi doubleValue];
        UC[clickIndex].DEX = [TFdex doubleValue];
        UC[clickIndex].MEN = [TFmen doubleValue];
        UC[clickIndex].INT = [TFint doubleValue];
        UC[clickIndex].LUK = [TFluk doubleValue];
    
    S = UC[clickIndex].STR + STRfix;
    V = UC[clickIndex].VIT + VITfix;
    A = UC[clickIndex].AGI + AGIfix;
    D = UC[clickIndex].DEX + DEXfix;
    M = UC[clickIndex].MEN + MENfix;
    I = UC[clickIndex].INT + INTfix;
    
    UC[clickIndex].ATK = (S*5 + D*2 + A)/8;
    UC[clickIndex].DEF = (V*5 + M*2 + S)/8;
    UC[clickIndex].CAP = (I*4 + D*1 + M*2)/7;
    UC[clickIndex].ACU = (D*4 + A*1 + M)/6;
    UC[clickIndex].EVA = (A*4 + A*1 + M)/6;
    
    
    
    
    [TFbp setStringValue:[NSString stringWithFormat:@"BP %g", (floor)(UC[clickIndex].BP)]];
    [TFatk setStringValue:[NSString stringWithFormat:@"攻撃力 %g", (floor)(UC[clickIndex].ATK)]];
    [TFdef setStringValue:[NSString stringWithFormat:@"防御力 %g", (floor)(UC[clickIndex].DEF)]];
    [TFcap setStringValue:[NSString stringWithFormat:@"演算力 %g", (floor)(UC[clickIndex].CAP)]];
    [TFacu setStringValue:[NSString stringWithFormat:@"命中値 %g", (floor)(UC[clickIndex].ACU)]];
    [TFeva setStringValue:[NSString stringWithFormat:@"回避値 %g", (floor)(UC[clickIndex].EVA)]];
}

-(void)addPUBEquipList{
    
    for (int i = 0; i < itemNumb; i++) {
        [PUPtEquip addItemWithTitle:EQ[i].name];
    }
}

-(void)initEquip{
    [self willChangeValueForKey:@"equipItemMA"];
    [equipItemMA removeAllObjects];
    [self didChangeValueForKey:@"equipItemMA"];
    eHeadFlag = false;
    eBodyFlag = false;
    eFootFlag = false;
    eArmFlag = false;
    eHandRFlag = false;
    eHandLFlag = false;
    
    if(UC[clickIndex].eHandR.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eHandR.name] forKey:@"name"];
        eHandRFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
    if(UC[clickIndex].eHandL.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eHandL.name] forKey:@"name"];
        eHandLFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
    if(UC[clickIndex].eHead.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eHead.name] forKey:@"name"];
        eHeadFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
    if(UC[clickIndex].eBody.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eBody.name] forKey:@"name"];
        eBodyFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
    if(UC[clickIndex].eFoot.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eFoot.name] forKey:@"name"];
        eFootFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
    if(UC[clickIndex].eArm.name != NULL) {
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].eArm.name] forKey:@"name"];
        eArmFlag = true;
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];}
}

-(IBAction)equipItemSelected:(id)sender{
    pubEquipItemIndex = [PUPtEquip indexOfSelectedItem];
    pubEquipItemIndex -= 1;
}

bool eHeadFlag = false;
bool eBodyFlag = false;
bool eFootFlag = false;
bool eArmFlag = false;
bool eHandRFlag = false;
bool eHandLFlag = false;

-(IBAction)insertEquip:(id)sender{
    
    if(pubEquipItemIndex >= 0){
        
        if(EQ[pubEquipItemIndex].type == 2){
            if(eHandLFlag) return;
            if(eHandRFlag) {
                eHandLFlag = true;
                UC[clickIndex].eHandL = EQ[pubEquipItemIndex];
            }else{
            UC[clickIndex].eHandR = EQ[pubEquipItemIndex];
                eHandRFlag = true;
            }
        }else if(EQ[pubEquipItemIndex].type == 3){
            if(eHeadFlag) return;
            UC[clickIndex].eHead = EQ[pubEquipItemIndex];
            eHeadFlag = true;
        }else if(EQ[pubEquipItemIndex].type == 4){
            if(eBodyFlag) return;
            UC[clickIndex].eBody = EQ[pubEquipItemIndex];
            eBodyFlag = true;
        }else if(EQ[pubEquipItemIndex].type == 5){
            if(eFootFlag) return;
            UC[clickIndex].eFoot = EQ[pubEquipItemIndex];
            eFootFlag = true;
        }else if(EQ[pubEquipItemIndex].type == 6){
            if(eArmFlag) return;
            UC[clickIndex].eArm = EQ[pubEquipItemIndex];
            eArmFlag = true;
        }
        
        NSMutableDictionary* dict = [NSMutableDictionary new];
        [dict setValue:[NSString stringWithFormat:@"%@", EQ[pubEquipItemIndex].name] forKey:@"name"];
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA insertObject:dict atIndex:[equipItemTV selectedRow]+1];
        [self didChangeValueForKey:@"equipItemMA"];
    }
}
-(IBAction)removeEquip:(id)sender{
    
    
    if([equipItemTV selectedRow] >= 0){
        
        if(EQ[[equipItemTV selectedRow]].type == 2){
            
            if(eHandLFlag){
                UC[clickIndex].eHandL = nilEquip;
                eHandLFlag = false;
            }else if(eHandRFlag){
                UC[clickIndex].eHandR = nilEquip;
                eHandRFlag = false;
            }
        }else if(EQ[[equipItemTV selectedRow]].type == 3){
            UC[clickIndex].eHead = nilEquip;
            eHeadFlag = false;
        }else if(EQ[[equipItemTV selectedRow]].type == 4){
            UC[clickIndex].eBody = nilEquip;
            eBodyFlag = false;
        }else if(EQ[[equipItemTV selectedRow]].type == 5){
            UC[clickIndex].eFoot = nilEquip;
            eFootFlag = false;
        }else if(EQ[[equipItemTV selectedRow]].type == 6){
            UC[clickIndex].eArm = nilEquip;
            eArmFlag = false;
        }
        
        
        
        [self willChangeValueForKey:@"equipItemMA"];
        [equipItemMA removeObjectAtIndex:[equipItemTV selectedRow]];
        [self didChangeValueForKey:@"equipItemMA"];
    }
}

-(void)doubleClickEQ:(id)sender{
    clickIndexEQ = [equipListTV clickedRow];
    
    [ILTFname setStringValue:EQ[clickIndexEQ].name];
    [ILTFnameR setStringValue:EQ[clickIndexEQ].nameRecognition];
    [ILTFnameID setStringValue:EQ[clickIndexEQ].nameID];
    
    [ILTFweight setDoubleValue:EQ[clickIndexEQ].Weight];
    [ILTFprice setDoubleValue:EQ[clickIndexEQ].price];
    [ILTFMOV setIntValue:EQ[clickIndexEQ].MOV];
    [ILTFHP setDoubleValue:EQ[clickIndexEQ].HP];
    [ILTFMP setDoubleValue:EQ[clickIndexEQ].MP];
    [ILTFAP setDoubleValue:EQ[clickIndexEQ].AP];
    [ILTFWT setDoubleValue:EQ[clickIndexEQ].WT];
    
    [ILTFSTR setDoubleValue:EQ[clickIndexEQ].STR];
    [ILTFVIT setDoubleValue:EQ[clickIndexEQ].VIT];
    [ILTFAGI setDoubleValue:EQ[clickIndexEQ].AGI];
    [ILTFDEX setDoubleValue:EQ[clickIndexEQ].DEX];
    [ILTFMEN setDoubleValue:EQ[clickIndexEQ].MEN];
    [ILTFINT setDoubleValue:EQ[clickIndexEQ].INT];
    [ILTFLUK setDoubleValue:EQ[clickIndexEQ].LUK];
    
    [ILTFpSTR setDoubleValue:EQ[clickIndexEQ].pSTR];
    [ILTFpVIT setDoubleValue:EQ[clickIndexEQ].pVIT];
    [ILTFpAGI setDoubleValue:EQ[clickIndexEQ].pAGI];
    [ILTFpDEX setDoubleValue:EQ[clickIndexEQ].pDEX];
    [ILTFpMEN setDoubleValue:EQ[clickIndexEQ].pMEN];
    [ILTFpINT setDoubleValue:EQ[clickIndexEQ].pINT];
    [ILTFpLUK setDoubleValue:EQ[clickIndexEQ].pLUK];
    
    [ILTFblow setIntValue:EQ[clickIndexEQ].R.blow];
    [ILTFslash setIntValue:EQ[clickIndexEQ].R.slash];
    [ILTFstub setIntValue:EQ[clickIndexEQ].R.stub];
    [ILTFarrow setIntValue:EQ[clickIndexEQ].R.arrow];
    [ILTFgun setIntValue:EQ[clickIndexEQ].R.gun];
    [ILTFshell setIntValue:EQ[clickIndexEQ].R.shell];
    [ILTFparalysis setIntValue:EQ[clickIndexEQ].R.paralysis];
    [ILTFpoison setIntValue:EQ[clickIndexEQ].R.poison];
    [ILTFcharm setIntValue:EQ[clickIndexEQ].R.charm];
    [ILTFconfusion setIntValue:EQ[clickIndexEQ].R.confusion];
    [ILTFsleep setIntValue:EQ[clickIndexEQ].R.sleep];
    [ILTFsilent setIntValue:EQ[clickIndexEQ].R.silent];
    
    [ILTFflame setIntValue:EQ[clickIndexEQ].R.flame];
    [ILTFcold setIntValue:EQ[clickIndexEQ].R.cold];
    [ILTFelectoric setIntValue:EQ[clickIndexEQ].R.electoric];
    [ILTFair setIntValue:EQ[clickIndexEQ].R.air];
    [ILTFwater setIntValue:EQ[clickIndexEQ].R.water];
    [ILTFgas setIntValue:EQ[clickIndexEQ].R.gas];
    [ILTFholy setIntValue:EQ[clickIndexEQ].R.holy];
    [ILTFdark setIntValue:EQ[clickIndexEQ].R.dark];
    [ILTFexplosion setIntValue:EQ[clickIndexEQ].R.explosion];
    [ILTFblood setIntValue:EQ[clickIndexEQ].R.blood];
    
    [ILTFrecHP setIntValue:EQ[clickIndexEQ].recHP];
    [ILTFrecHPp setIntValue:EQ[clickIndexEQ].recpHP];
    [ILTFrecMP setIntValue:EQ[clickIndexEQ].recMP];
    [ILTFrecMPp setIntValue:EQ[clickIndexEQ].recpMP];
    [ILTFcomment setStringValue:EQ[clickIndexEQ].comment];
    
    [ILPUBtype selectItemAtIndex:EQ[clickIndexEQ].type];
    
    UCLDpoint.x = [UCLPanelEquipList frame].origin.x + 0;
    UCLDpoint.y = [UCLPanelEquipList frame].origin.y + 0;
    [UCLPanelEquipDetail setFrameOrigin:UCLDpoint];
    [UCLPanelEquipDetail makeKeyAndOrderFront:nil];
}

-(IBAction)saveIL:(id)sender{
    
    EQ[clickIndexEQ].name = [[ILTFname stringValue] retain];
    EQ[clickIndexEQ].nameRecognition = [[ILTFnameR stringValue] retain];
    EQ[clickIndexEQ].nameID = [[ILTFnameID stringValue] retain];
    
    EQ[clickIndexEQ].Weight = [ILTFweight doubleValue];
    EQ[clickIndexEQ].price = [ILTFprice doubleValue];
    EQ[clickIndexEQ].MOV = [ILTFMOV intValue];
    EQ[clickIndexEQ].HP = [ILTFHP doubleValue];
    EQ[clickIndexEQ].MP = [ILTFMP doubleValue];
    EQ[clickIndexEQ].AP = [ILTFAP doubleValue];
    EQ[clickIndexEQ].WT = [ILTFWT doubleValue];
    
    EQ[clickIndexEQ].STR = [ILTFSTR doubleValue];
    EQ[clickIndexEQ].VIT = [ILTFVIT doubleValue];
    EQ[clickIndexEQ].AGI = [ILTFAGI doubleValue];
    EQ[clickIndexEQ].DEX = [ILTFDEX doubleValue];
    EQ[clickIndexEQ].MEN = [ILTFMEN doubleValue];
    EQ[clickIndexEQ].INT = [ILTFINT doubleValue];
    EQ[clickIndexEQ].LUK = [ILTFLUK doubleValue];
    
    EQ[clickIndexEQ].pSTR = [ILTFpSTR doubleValue];
    EQ[clickIndexEQ].pVIT = [ILTFpVIT doubleValue];
    EQ[clickIndexEQ].pAGI = [ILTFpAGI doubleValue];
    EQ[clickIndexEQ].pDEX = [ILTFpDEX doubleValue];
    EQ[clickIndexEQ].pMEN = [ILTFpMEN doubleValue];
    EQ[clickIndexEQ].pINT = [ILTFpINT doubleValue];
    EQ[clickIndexEQ].pLUK = [ILTFpLUK doubleValue];
    
    EQ[clickIndexEQ].R.blow = [ILTFblow intValue];
    EQ[clickIndexEQ].R.slash = [ILTFslash intValue];
    EQ[clickIndexEQ].R.stub = [ILTFstub intValue];
    EQ[clickIndexEQ].R.arrow = [ILTFarrow intValue];
    EQ[clickIndexEQ].R.gun = [ILTFgun intValue];
    EQ[clickIndexEQ].R.shell = [ILTFshell intValue];
    EQ[clickIndexEQ].R.paralysis = [ILTFparalysis intValue];
    EQ[clickIndexEQ].R.poison = [ILTFpoison intValue];
    EQ[clickIndexEQ].R.charm = [ILTFcharm intValue];
    EQ[clickIndexEQ].R.confusion = [ILTFconfusion intValue];
    EQ[clickIndexEQ].R.sleep = [ILTFsleep intValue];
    EQ[clickIndexEQ].R.silent = [ILTFsilent intValue];
    
    EQ[clickIndexEQ].R.flame = [ILTFflame intValue];
    EQ[clickIndexEQ].R.cold = [ILTFcold intValue];
    EQ[clickIndexEQ].R.electoric = [ILTFelectoric intValue];
    EQ[clickIndexEQ].R.air = [ILTFair intValue];
    EQ[clickIndexEQ].R.water = [ILTFwater intValue];
    EQ[clickIndexEQ].R.gas = [ILTFgas intValue];
    EQ[clickIndexEQ].R.holy = [ILTFholy intValue];
    EQ[clickIndexEQ].R.dark = [ILTFdark intValue];
    EQ[clickIndexEQ].R.explosion = [ILTFexplosion intValue];
    EQ[clickIndexEQ].R.blood = [ILTFblood intValue];
    
    EQ[clickIndexEQ].recHP = [ILTFrecHP intValue];
    EQ[clickIndexEQ].recpHP = [ILTFrecHPp intValue];
    EQ[clickIndexEQ].recMP = [ILTFrecMP intValue];
    EQ[clickIndexEQ].recpMP = [ILTFrecMPp intValue];
    EQ[clickIndexEQ].comment = [ILTFcomment stringValue];
    
    EQ[clickIndexEQ].type = (int)[ILPUBtype indexOfSelectedItem];
    
    [equipListAC setValue:[NSString stringWithFormat:@"%@", EQ[clickIndexEQ].name] forKeyPath:@"selection.name"];
    
    NSString *str = @"";
    
    if(EQ[clickIndexEQ].HP != 0)
        str = [str stringByAppendingFormat:@"HP %d ", (int)EQ[clickIndexEQ].HP];
    if(EQ[clickIndexEQ].MP != 0)
        str = [str stringByAppendingFormat:@"MP %d ", (int)EQ[clickIndexEQ].MP];
    if(EQ[clickIndexEQ].STR != 0)
        str = [str stringByAppendingFormat:@"STR %d ", (int)EQ[clickIndexEQ].STR];
    if(EQ[clickIndexEQ].VIT != 0)
        str = [str stringByAppendingFormat:@"VIT %d ", (int)EQ[clickIndexEQ].VIT];
    if(EQ[clickIndexEQ].AGI != 0)
        str = [str stringByAppendingFormat:@"AGI %d ", (int)EQ[clickIndexEQ].AGI];
    if(EQ[clickIndexEQ].DEX != 0)
        str = [str stringByAppendingFormat:@"DEX %d ", (int)EQ[clickIndexEQ].DEX];
    if(EQ[clickIndexEQ].MEN != 0)
        str = [str stringByAppendingFormat:@"MEN %d ", (int)EQ[clickIndexEQ].MEN];
    if(EQ[clickIndexEQ].INT != 0)
        str = [str stringByAppendingFormat:@"INT %d ", (int)EQ[clickIndexEQ].INT];
    if(EQ[clickIndexEQ].LUK != 0)
        str = [str stringByAppendingFormat:@"LUK %d ", (int)EQ[clickIndexEQ].LUK];
    if(EQ[clickIndexEQ].Weight != 0)
        str = [str stringByAppendingFormat:@"重さ %d ", (int)EQ[clickIndexEQ].Weight];
    
    [equipListAC setValue:[NSString stringWithFormat:@"%@", str] forKeyPath:@"selection.memo"];
    
    [UCLPanelEquipDetail close];
}
-(IBAction)canceIL:(id)sender{
    [UCLPanelEquipDetail close];
}

-(void)doubleClickAL:(id)sender{
    clickIndexAL = [attackListTV clickedRow];
    
    [self willChangeValueForKey:@"damageListMA"];
    [damageListMA removeAllObjects];
    [self didChangeValueForKey:@"damageListMA"];
    
    [ALTFname setStringValue:UC[clickIndex].A->name];
    [ALTFrangeA setIntValue:UC[clickIndex].A->rangeA];
    [ALTFrangeB setIntValue:UC[clickIndex].A->rangeB];
    [ALTFextend setIntValue:UC[clickIndex].A->extent];
    
    [ALTFtrigger setIntValue:UC[clickIndex].A->trig];
    [ALTFmelee setIntValue:UC[clickIndex].A->melee];
    [ALTFpass setIntValue:UC[clickIndex].A->P];
    [ALTFdmgExtent setIntValue:UC[clickIndex].A->dmgExtend];
    [ALPUBwType selectItemAtIndex:UC[clickIndex].A->type];
    
    [ALTFcost setIntValue:UC[clickIndex].A->MP];
    [ALTFcostP setIntValue:UC[clickIndex].A->pMP];
    [ALTFbullet setIntValue:UC[clickIndex].A->bullet];
    [ALTFhitCount setIntValue:UC[clickIndex].A->hitCount];
    [ALTFsuccessRate setIntValue:UC[clickIndex].A->successRate];
    [ALTFvigor setIntValue:UC[clickIndex].A->vigor];
    [ALTFhitRate setIntValue:UC[clickIndex].A->hitPercent];
    
    [ALPUBriku selectItemAtIndex:UC[clickIndex].A->riku];
    [ALPUBchu selectItemAtIndex:UC[clickIndex].A->chu];
    [ALPUBumi selectItemAtIndex:UC[clickIndex].A->umi];
    [ALPUBsora selectItemAtIndex:UC[clickIndex].A->sora];
    
    [ALTFcSupply setIntValue:UC[clickIndex].A->cSupply];
    [ALTFcFood setIntValue:UC[clickIndex].A->cFood];
    [ALTFcMoney setIntValue:UC[clickIndex].A->cMoney];
    
    [ALTFcmd setStringValue:UC[clickIndex].A->cmd];
    //[ALTFmsg setStringValue:UC[clickIndex].A->msg];
    
    
    
    NSMutableDictionary* dict = [NSMutableDictionary new];
    
    if(UC[clickIndex].A->D->type == 0)
        [dict setValue:[NSString stringWithFormat:@"攻%g+%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];
    if(UC[clickIndex].A->D->type == 1)
        [dict setValue:[NSString stringWithFormat:@"防%g+%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];
    if(UC[clickIndex].A->D->type == 2)
        [dict setValue:[NSString stringWithFormat:@"命%g+%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];
    if(UC[clickIndex].A->D->type == 3)
        [dict setValue:[NSString stringWithFormat:@"回%g+%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];
    if(UC[clickIndex].A->D->type == 4)
        [dict setValue:[NSString stringWithFormat:@"演%g+%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];
    if(UC[clickIndex].A->D->type == 5)
        [dict setValue:[NSString stringWithFormat:@"会%g%g％", UC[clickIndex].A->D->count, UC[clickIndex].A->D->pCount] forKey:@"count"];

    NSString *str;
    
    if(UC[clickIndex].A->D->sort == 0) str = [NSString stringWithFormat:@"ダ・"];
    if(UC[clickIndex].A->D->sort == 1) str = [NSString stringWithFormat:@"回・"];
    if(UC[clickIndex].A->D->sort == 2) str = [NSString stringWithFormat:@"復・"];
    if(UC[clickIndex].A->D->sort == 3) str = [NSString stringWithFormat:@"減・"];
    if(UC[clickIndex].A->D->sort == 4) str = [NSString stringWithFormat:@"増・"];
    if(UC[clickIndex].A->D->sort == 5) str = [NSString stringWithFormat:@"毒・"];
    if(UC[clickIndex].A->D->sort == 6) str = [NSString stringWithFormat:@"睡・"];
    if(UC[clickIndex].A->D->sort == 7) str = [NSString stringWithFormat:@"混・"];
    if(UC[clickIndex].A->D->sort == 8) str = [NSString stringWithFormat:@"麻・"];
    if(UC[clickIndex].A->D->sort == 9) str = [NSString stringWithFormat:@"沈・"];
    if(UC[clickIndex].A->D->sort == 10) str = [NSString stringWithFormat:@"魅・"];
    
    if(UC[clickIndex].A->D->seed == 0) str = [str stringByAppendingFormat:@"打撃"];
    if(UC[clickIndex].A->D->seed == 1) str = [str stringByAppendingFormat:@"斬撃"];
    if(UC[clickIndex].A->D->seed == 2) str = [str stringByAppendingFormat:@"突き"];
    if(UC[clickIndex].A->D->seed == 3) str = [str stringByAppendingFormat:@"射手"];
    if(UC[clickIndex].A->D->seed == 4) str = [str stringByAppendingFormat:@"銃撃"];
    if(UC[clickIndex].A->D->seed == 5) str = [str stringByAppendingFormat:@"砲撃"];
    if(UC[clickIndex].A->D->seed == 6) str = [str stringByAppendingFormat:@"火炎"];
    if(UC[clickIndex].A->D->seed == 7) str = [str stringByAppendingFormat:@"冷気"];
    if(UC[clickIndex].A->D->seed == 8) str = [str stringByAppendingFormat:@"電撃"];
    if(UC[clickIndex].A->D->seed == 9) str = [str stringByAppendingFormat:@"風圧"];
    if(UC[clickIndex].A->D->seed == 10) str = [str stringByAppendingFormat:@"流水"];
    if(UC[clickIndex].A->D->seed == 11) str = [str stringByAppendingFormat:@"ガス"];
    if(UC[clickIndex].A->D->seed == 12) str = [str stringByAppendingFormat:@"神聖"];
    if(UC[clickIndex].A->D->seed == 13) str = [str stringByAppendingFormat:@"暗黒"];
    if(UC[clickIndex].A->D->seed == 14) str = [str stringByAppendingFormat:@"爆撃"];
    if(UC[clickIndex].A->D->seed == 15) str = [str stringByAppendingFormat:@"流血"];
    
    [dict setValue:[NSString stringWithFormat:@"%@", str] forKey:@"type"];
    [self willChangeValueForKey:@"damageListMA"];
    [damageListMA insertObject:dict atIndex:[damageListTV selectedRow]+1];
    [self didChangeValueForKey:@"damageListMA"];
    
    UCLDpoint.x = [UCLPanelAttack frame].origin.x + 0;
    UCLDpoint.y = [UCLPanelAttack frame].origin.y + 0;
    [UCLPanelAttackDetail setFrameOrigin:UCLDpoint];
    [UCLPanelAttackDetail makeKeyAndOrderFront:nil];
}

-(void)doubleClickUCL:(id)sender{
    clickIndex = [unitChipListTV clickedRow];
    
    [TFname setStringValue:UC[clickIndex].name];
    [TFnameN setStringValue:UC[clickIndex].nameNick];
    [TFnameR setStringValue:UC[clickIndex].nameRecognition];
    [TFnameID setStringValue:UC[clickIndex].nameID];
    [TFnameC setStringValue:UC[clickIndex].nameClass];
    
    
    [TFhp setDoubleValue:UC[clickIndex].HP];
    [TFmp setDoubleValue:UC[clickIndex].MP];
    [TFap setDoubleValue:UC[clickIndex].AP];
    [TFwt setDoubleValue:UC[clickIndex].WT];
    
    [TFbp setStringValue:[NSString stringWithFormat:@"BP %g", UC[clickIndex].BP]];
    [TFatk setStringValue:[NSString stringWithFormat:@"攻撃力 %g", UC[clickIndex].ATK]];
    [TFdef setStringValue:[NSString stringWithFormat:@"防御力 %g", UC[clickIndex].DEF]];
    [TFcap setStringValue:[NSString stringWithFormat:@"演算力 %g", UC[clickIndex].CAP]];
    [TFacu setStringValue:[NSString stringWithFormat:@"命中値 %g", UC[clickIndex].ACU]];
    [TFeva setStringValue:[NSString stringWithFormat:@"回避値 %g", UC[clickIndex].EVA]];
    
    [TFstr setDoubleValue:UC[clickIndex].STR];
    [TFvit setDoubleValue:UC[clickIndex].VIT];
    [TFagi setDoubleValue:UC[clickIndex].AGI];
    [TFdex setDoubleValue:UC[clickIndex].DEX];
    [TFmen setDoubleValue:UC[clickIndex].MEN];
    [TFint setDoubleValue:UC[clickIndex].INT];
    [TFluk setDoubleValue:UC[clickIndex].LUK];
    [TFmov setIntValue:UC[clickIndex].MOV];
    
    [TFmel setDoubleValue:UC[clickIndex].MEL];
    [TFmis setDoubleValue:UC[clickIndex].MIS];
    [TFhit setDoubleValue:UC[clickIndex].HIT];
    [TFdod setDoubleValue:UC[clickIndex].DOD];
    [TFrea setDoubleValue:UC[clickIndex].REA];
    [TFski setDoubleValue:UC[clickIndex].SKI];
    
    [TFcSupply setIntValue:UC[clickIndex].cSupply];
    [TFcFood setIntValue:UC[clickIndex].cFood];
    [TFcMoney setIntValue:UC[clickIndex].cMoney];
    
    [PUPtMons selectItemAtIndex:UC[clickIndex].typeMONS];
    [PUPtMove selectItemAtIndex:UC[clickIndex].typeMOVE];
    //[PUPtEquip selectItemAtIndex:UC[clickIndex].typeMOVE];
    
    [IVimg setImage:UC[clickIndex].img];
    [IVimgBig setImage:UC[clickIndex].imgb];
    
    
    [self initEquip];
    
    UCLDpoint.x = [UCLPanel frame].origin.x + 50;
    UCLDpoint.y = [UCLPanel frame].origin.y + 100;
    [UCLDetailPanel setFrameOrigin:UCLDpoint];
    [UCLDetailPanel makeKeyAndOrderFront:nil];
}

-(IBAction)saveUCL:(id)sender{
    
    UC[clickIndex].name = [[TFname stringValue] retain];
    UC[clickIndex].nameNick = [[TFnameN stringValue] retain];
    UC[clickIndex].nameRecognition = [[TFnameR stringValue] retain];
    UC[clickIndex].nameID = [[TFnameID stringValue] retain];
    UC[clickIndex].nameClass = [[TFnameC stringValue] retain];
    
    UC[clickIndex].HP = [TFhp doubleValue];
    UC[clickIndex].MP = [TFmp doubleValue];
    UC[clickIndex].AP = [TFap doubleValue];
    UC[clickIndex].WT = [TFwt doubleValue];
    
    UC[clickIndex].STR = [TFstr doubleValue];
    UC[clickIndex].VIT = [TFvit doubleValue];
    UC[clickIndex].AGI = [TFagi doubleValue];
    UC[clickIndex].DEX = [TFdex doubleValue];
    UC[clickIndex].MEN = [TFmen doubleValue];
    UC[clickIndex].INT = [TFint doubleValue];
    UC[clickIndex].LUK = [TFluk doubleValue];
    UC[clickIndex].MOV = [TFmov intValue];
    
    UC[clickIndex].MEL = [TFmel doubleValue];
    UC[clickIndex].MIS = [TFmis doubleValue];
    UC[clickIndex].HIT = [TFhit doubleValue];
    UC[clickIndex].DOD = [TFdod doubleValue];
    UC[clickIndex].REA = [TFrea doubleValue];
    UC[clickIndex].SKI = [TFski doubleValue];
    
    UC[clickIndex].cSupply = [TFcSupply intValue];
    UC[clickIndex].cFood = [TFcFood intValue];
    UC[clickIndex].cMoney = [TFcMoney intValue];
    
    UC[clickIndex].typeMONS = (int)[PUPtMons indexOfSelectedItem];
    UC[clickIndex].typeMOVE = (int)[PUPtMove indexOfSelectedItem];
    
    UC[clickIndex].img = [[IVimg image] retain];
    UC[clickIndex].imgb = [[IVimgBig image] retain];
    
    [unitChipListAC setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].name] forKeyPath:@"selection.name"];
    [unitChipListAC setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].nameClass] forKeyPath:@"selection.nameC"];
    [unitChipListAC setValue:[NSString stringWithFormat:@"%g", UC[clickIndex].HP] forKeyPath:@"selection.HP"];
    [unitChipListAC setValue:[NSString stringWithFormat:@"%g", UC[clickIndex].BP] forKeyPath:@"selection.BP"];
    [unitChipListAC setValue:UC[clickIndex].img forKeyPath:@"selection.img"];
    
    
    [self saveData];
    [UCLDetailPanel close];
}
-(IBAction)cancelUCL:(id)sender{
    [UCLDetailPanel close];
}

-(void)initFileDirectory{
    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    char *cwd;
    cwd = getcwd(NULL, 0);
    
    
    NSData *InitialData = [NSData dataWithContentsOfFile:@"data/UnitChip/preset.txt"];
    NSString *pathUC = @"data/UnitChip/img";
    NSString *pathDATA2 = @"data/UnitChip/preset.txt";
    NSString *pathUCP = @"data/UnitChip/preset.txt";
    NSString *fileData = nil;
    
    chipNumb = 56;
    if(!InitialData){
        [[NSFileManager defaultManager] createDirectoryAtPath:pathUC withIntermediateDirectories:YES attributes:nil error:nil];
        [[NSFileManager defaultManager] createFileAtPath:pathDATA2 contents:nil attributes:nil];
        
        [[NSFileManager defaultManager] createFileAtPath:pathUCP contents:nil attributes:nil];
        
        NSString *data1 = @"村人\n村人\nパーサント\n村人,uc1\n100,50,0,500,5\n30,30,30,30,30,30,0,9\n100,100,100,100,100,100\n100,100,100,100,100\n0,0,0,50,0\nuc1.png,ucb1.png\n----\n----\n----\n";
        NSString *data2 = @"兵士\n兵士\nソルジャー\n兵士,uc2\n150,80,0,520,6\n50,40,45,40,35,35,0,10\n120,120,100,100,120,130\n100,100,100,100,100\n0,0,0,50,50\nuc2.png,ucb2.png\n----\n----\n----\n";
        NSString *data3 = @"戦士\n戦士\nファイター\n戦士,uc3\n200,100,0,550,6\n55,50,30,40,40,32,0,9\n130,110,100,100,125,135\n100,100,100,100,100\n0,0,0,80,30\nuc3.png,ucb3.png\n----\n----\n----\n";
        NSString *data4 = @"女蛮族\n女蛮族\nアマゾネス\n女蛮族,uc4\n120,70,0,480,5\n40,35,50,50,45,36,0,10\n110,130,120,120,130,130\n100,100,100,100,100\n0,0,0,30,40\nuc4.png,ucb4.png\n----\n----\n----\n";
        NSString *data5 = @"僧徒\n僧徒\nアコライト\n僧徒,uc5\n130,100,0,540,5\n35,32,40,36,55,50,0,8\n105,110,105,100,125,125\n100,100,100,100,100\n0,0,0,20,100\nuc5.png,ucb5.png\n----\n----\n----\n";
        NSString *data6 = @"魔法使い\n魔法使い\nマジシャン\n魔法使い,uc6\n120,150,0,490,5\n38,32,42,45,50,60,0,8\n105,120,120,120,130,140\n100,100,100,100,100\n0,0,100,30,80\nuc6.png,ucb6.png\n----\n----\n----\n";

        NSString *data7 = @"盗賊\n盗賊\nシーフ\n盗賊,uc7\n140,90,0,450,6\n45,40,60,50,45,40,0,12\n110,115,130,140,130,145\n100,100,100,100,100\n0,0,0,60,40\nuc7.png,ucb7.png\n----\n----\n----\n";
        NSString *data8 = @"騎士\n騎士\nナイト\n騎士,uc8\n225,100,0,500,6\n60,50,50,55,55,50,0,10\n130,125,120,120,125,130\n100,100,100,100,100\n0,0,0,60,80\nuc8.png,ucb8.png\n----\n----\n----\n";
        NSString *data9 = @"狂戦士\n狂戦士\nバーサーカー\n狂戦士,uc9\n255,80,0,470,6\n70,40,55,60,58,40,0,11\n140,110,130,110,130,140\n100,100,100,100,100\n0,0,0,100,50\nuc9.png,ucb9.png\n----\n----\n----\n";
        NSString *data10 = @"闘技士\n闘技士\nグラディエーター\n闘技士,uc10\n300,100,0,450,6\n80,45,60,65,60,50,0,11\n135,120,125,120,135,135\n100,100,100,100,100\n0,0,0,80,70\nuc10.png,ucb10.png\n----\n----\n----\n";
        NSString *data11 = @"傭兵\n傭兵\nマーシナリ\n傭兵,uc11\n200,100,0,480,6\n55,40,60,60,55,40,0,10\n120,120,120,120,130,130\n100,100,100,100,100\n0,0,0,60,60\nuc11.png,ucb11.png\n----\n----\n----\n";
        NSString *data12 = @"弓士\n弓士\nアーチャー\n弓士,uc12\n180,90,0,500,6\n50,50,55,55,50,50,0,11\n120,120,120,120,120,120\n100,100,100,100,100\n0,0,50,50,50\nuc12.png,ucb12.png\n----\n----\n----\n";
        NSString *data13 = @"僧侶\n僧侶\nプリースト\n僧侶,uc13\n160,150,0,500,5\n38,34,50,60,60,60,0,8\n110,110,120,120,125,130\n100,100,100,100,100\n0,0,0,30,150\nuc13.png,ucb13.png\n----\n----\n----\n";
        NSString *data14 = @"魔術師\n魔術師\nウィザード\n魔術師,uc14\n150,200,0,450,5\n40,36,54,58,60,80,0,8\n105,130,130,150,150,150\n100,100,100,100,100\n0,0,200,30,100\nuc14.png,ucb14.png\n----\n----\n----\n";
        NSString *data15 = @"祈祷師\n祈祷師\nシャーマン\n祈祷師,uc15\n140,180,0,520,5\n50,50,50,60,80,60,0,8\n110,120,130,130,140,140\n100,100,100,100,100\n0,0,60,40,50\nuc15.png,ucb15.png\n----\n----\n----\n";
        NSString *data16 = @"奇術師\n奇術師\nドルイド\n奇術師,uc16\n180,150,0,460,5\n45,40,60,75,65,65,0,9\n120,120,130,130,130,150\n100,100,100,100,100\n0,0,40,60,60\nuc16.png,ucb16.png\n----\n----\n----\n";
        NSString *data17 = @"魔女\n魔女\nウィッチ\n魔女,uc17\n130,200,0,480,5\n35,45,55,80,80,80,0,9\n110,130,150,140,150,150\n100,100,100,100,100\n0,0,300,30,150\nuc17.png,ucb17.png\n----\n----\n----\n";
        NSString *data18 = @"侍\n侍\nサムライ\n侍,uc18\n200,100,0,450,6\n70,35,70,70,65,45,0,11\n150,110,150,150,150,150\n100,100,100,100,100\n0,0,0,120,0\nuc18.png,ucb18.png\n----\n----\n----\n";
        NSString *data19 = @"聖騎士\n聖騎士\nホワイトナイト\n聖騎士,uc19\n250,150,0,420,6\n98,50,76,82,74,52,0,11\n140,130,160,160,150,150\n100,100,100,100,100\n0,0,0,50,200\nuc19.png,ucb19.png\n----\n----\n----\n";
        NSString *data20 = @"黒騎士\n黒騎士\nブラックナイト\n黒騎士,uc20\n270,180,0,460,6\n82,86,60,80,78,60,0,10\n140,140,150,150,150,150\n100,100,100,100,100\n0,0,0,100,150\nuc20.png,ucb20.png\n----\n----\n----\n";
        NSString *data21 = @"亡霊騎士\n亡霊騎士\nスタンジャンナイト\n亡霊騎士,uc21\n300,200,0,500,6\n120,150,45,60,50,40,0,9\n150,120,120,120,120,120\n100,100,100,100,100\n0,0,300,0,100\nuc21.png,ucb21.png\n----\n----\n----\n";
        NSString *data22 = @"王国騎士\n王国騎士\nレギオン\n王国騎士,uc22\n260,160,0,450,6\n90,90,60,70,70,60,0,11\n150,130,150,150,150,150\n100,100,100,100,100\n0,0,0,100,300\nuc22.png,ucb22.png\n----\n----\n----\n";
        NSString *data23 = @"怪盗\n怪盗\nレンジャー\n怪盗,uc23\n230,200,0,400,6\n76,68,92,98,86,72,0,12\n130,140,160,160,155,160\n100,100,100,100,100\n0,0,100,100,100\nuc23.png,ucb23.png\n----\n----\n----\n";
        NSString *data24 = @"上級僧侶\n上級僧侶\nハイプリースト\n上級僧侶,uc24\n200,250,0,480,6\n60,76,64,82,94,90,0,12\n120,120,150,140,145,150\n100,100,100,100,100\n0,0,0,30,250\nuc24.png,ucb24.png\n----\n----\n----\n";
        NSString *data25 = @"言語術士\n言語術士\nワーロック\n言語術士,uc25\n130,300,0,460,5\n34,46,52,75,120,130,0,9\n105,110,140,120,150,155\n100,100,100,100,100\n0,0,500,30,300\nuc25.png,ucb25.png\n----\n----\n----\n";
        NSString *data26 = @"聖女\n聖女\nセイレーン\n聖女,uc26\n150,255,0,470,5\n38,34,68,80,98,112,0,9\n105,150,150,120,140,150\n100,100,100,100,100\n0,0,300,50,200\nuc26.png,ucb26.png\n----\n----\n----\n";
        NSString *data27 = @"言霊使い\n言霊使い\nソーサレス\n言霊使い,uc27\n170,240,0,460,5\n48,40,78,76,85,98,0,9\n120,130,140,140,145,145\n100,100,100,100,100\n0,0,200,30,100\nuc27.png,ucb27.png\n----\n----\n----\n";
        NSString *data28 = @"錬金術士\n錬金術士\nアルケミスト\n錬金術士,uc28\n200,200,0,450,5\n55,60,82,96,70,100,0,9\n140,140,140,140,140,150\n100,100,100,100,100\n0,0,500,50,500\nuc28.png,ucb28.png\n----\n----\n----\n";
        NSString *data29 = @"神聖騎士\n神聖騎士\nパラディン\n神聖騎士,uc29\n320,230,0,400,7\n120,100,130,115,100,100,0,11\n150,130,150,150,150,150\n100,100,100,100,100\n0,0,0,50,400\nuc29.png,ucb29.png\n----\n----\n----\n";
        NSString *data30 = @"暗黒騎士\n暗黒騎士\nテラーナイト\n暗黒騎士,uc30\n400,150,0,420,7\n130,130,90,100,94,64,0,10\n150,120,150,150,150,150\n100,100,100,100,100\n0,0,0,100,200\nuc30.png,ucb30.png\n----\n----\n----\n";
        NSString *data31 = @"教皇騎士\n教皇騎士\nテンプルナイト\n教皇騎士,uc31\n360,250,0,400,7\n100,100,100,100,100,100,0,10\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,200,100,300\nuc31.png,ucb31.png\n----\n----\n----\n";
        NSString *data32 = @"狙撃手\n狙撃手\nスナイパー\n狙撃手,uc32\n200,160,0,450,5\n60,50,90,90,80,70,0,10\n110,150,180,130,150,150\n100,100,100,100,100\n0,0,200,100,300\nuc32.png,ucb32.png\n----\n----\n----\n";
        NSString *data33 = @"司祭\n司祭\nビショップ\n司祭,uc33\n240,400,0,450,5\n62,80,70,98,110,120,0,9\n125,125,150,150,150,150\n100,100,100,100,100\n0,0,0,50,500\nuc33.png,ucb33.png\n----\n----\n----\n";
        NSString *data34 = @"賢者\n賢者\nセイジ\n賢者,uc34\n230,500,0,400,6\n98,86,94,98,120,150,0,10\n130,140,150,150,150,150\n100,100,100,100,100\n0,0,250,50,250\nuc34.png,ucb34.png\n----\n----\n----\n";
        NSString *data35 = @"将軍\n将軍\nジェネラル\n将軍,uc35\n500,200,0,500,6\n130,150,60,84,76,85,0,8\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc35.png,ucb35.png\n----\n----\n----\n";
        NSString *data36 = @"千人長\n千人長\nハイランダー\n千人長,uc36\n600,300,0,450,6\n150,140,80,130,96,120,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc36.png,ucb36.png\n----\n----\n----\n";
        NSString *data37 = @"男爵\n男爵\nバロン\n男爵,uc37\n550,500,0,520,6\n100,180,50,90,120,100,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc37.png,ucb37.png\n----\n----\n----\n";
        NSString *data38 = @"公爵\n公爵\nデューク\n公爵,uc38\n430,320,0,400,6\n150,150,120,125,120,120,0,10\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc38.png,ucb38.png\n----\n----\n----\n";
        NSString *data39 = @"魔導士\n魔導士\nアークメイジ\n魔導士,uc39\n200,500,0,450,6\n60,50,78,98,140,140,0,9\n120,130,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc39.png,ucb39.png\n----\n----\n----\n";
        NSString *data40 = @"召喚師\n召喚師\nサモナー\n召喚師,uc40\n220,550,0,480,5\n50,50,60,80,150,150,0,9\n125,125,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc40.png,ucb40.png\n----\n----\n----\n";
        NSString *data41 = @"古語術士\n古語術士\nルーンマスター\n古語術士,uc41\n180,600,0,500,5\n90,90,90,90,150,150,0,9\n120,130,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc41.png,ucb41.png\n----\n----\n----\n";
        NSString *data42 = @"死霊使い\n死霊使い\nネクロマンサー\n死霊使い,uc42\n210,700,0,500,5\n50,60,70,140,150,150,0,9\n130,130,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc42.png,ucb42.png\n----\n----\n----\n";
        NSString *data43 = @"占星術士\n占星術士\nアストロマンサー\n占星術士,uc43\n250,800,0,400,5\n80,70,120,150,150,150,0,9\n130,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc43.png,ucb43.png\n----\n----\n----\n";
        NSString *data44 = @"勇者\n勇者\nロード\n勇者,uc44\n500,250,0,400,6\n125,125,125,125,125,125,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc44.png,ucb44.png\n----\n----\n----\n";
        NSString *data45 = @"王子\n王子\nプリンス\n王子,uc45\n600,300,0,400,6\n120,100,100,120,130,120,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc45.png,ucb45.png\n----\n----\n----\n";
        NSString *data46 = @"王女\n王女\nプリンセス\n王女,uc46\n450,400,0,400,6\n100,100,120,120,120,120,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc46.png,ucb46.png\n----\n----\n----\n";
        NSString *data47 = @"教皇\n教皇\nポープ\n教皇,uc47\n500,500,0,500,6\n100,100,100,150,150,150,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc47.png,ucb47.png\n----\n----\n----\n";
        NSString *data48 = @"枢機卿\n枢機卿\nカーディナル\n枢機卿,uc48\n400,400,0,550,6\n40,40,80,90,100,120,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc48.png,ucb48.png\n----\n----\n----\n";
        NSString *data49 = @"大司教\n大司教\nアークビショップ\n大司教,uc49\n300,900,0,450,6\n50,50,100,150,150,150,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc49.png,ucb49.png\n----\n----\n----\n";
        NSString *data50 = @"王\n王\nキング\n王,uc50\n500,250,0,500,6\n50,50,50,100,130,120,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc50.png,ucb50.png\n----\n----\n----\n";
        NSString *data51 = @"女王\n女王\nクイーン\n女王,uc51\n500,500,0,450,6\n50,50,50,130,120,100,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc51.png,ucb51.png\n----\n----\n----\n";

        NSString *data52 = @"皇帝\n皇帝\nエンペラー\n皇帝,uc52\n900,800,0,450,6\n150,150,150,150,150,150,0,9\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc52.png,ucb52.png\n----\n----\n----\n";
        NSString *data53 = @"三日月王\n三日月王\nクレセント\n三日月王,uc53\n1200,1000,150,400,6\n200,160,180,230,220,180,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc53.png,ucb53.png\n----\n----\n----\n";
        NSString *data54 = @"月の王\n月の王\nセレス\n月の王,uc54\n1500,1000,200,400,6\n225,200,210,250,255,255,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc54.png,ucb54.png\n----\n----\n----\n";
        NSString *data55 = @"日蝕王\n日蝕王\nイクリプス\n日蝕王,uc55\n2500,1500,250,400,6\n250,230,240,250,255,255,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc55.png,ucb55.png\n----\n----\n----\n";
        NSString *data56 = @"彗星王\n彗星王\nコメット\n彗星王,uc56\n5000,2500,300,400,6\n255,255,255,255,255,255,0,11\n150,150,150,150,150,150\n100,100,100,100,100\n0,0,0,100,1000\nuc56.png,ucb56.png\n----\n----\n----\n";
        
        for (int i=1; i<=chipNumb; i++) {
            NSString *fdata = @"data/UnitChip/UCdata";
            
            fdata = [fdata stringByAppendingFormat:@"%d.txt", i];
            
            switch (i) {
                case 1:
                    [data1 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 2:
                    [data2 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 3:
                    [data3 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 4:
                    [data4 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 5:
                    [data5 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 6:
                    [data6 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 7:
                    [data7 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 8:
                    [data8 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 9:
                    [data9 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 10:
                    [data10 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 11:
                    [data11 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 12:
                    [data12 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 13:
                    [data13 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 14:
                    [data14 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 15:
                    [data15 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 16:
                    [data16 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 17:
                    [data17 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 18:
                    [data18 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 19:
                    [data19 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 20:
                    [data20 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 21:
                    [data21 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 22:
                    [data22 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 23:
                    [data23 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 24:
                    [data24 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 25:
                    [data25 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 26:
                    [data26 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 27:
                    [data27 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 28:
                    [data28 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 29:
                    [data29 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 30:
                    [data30 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 31:
                    [data31 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 32:
                    [data32 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 33:
                    [data33 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 34:
                    [data34 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 35:
                    [data35 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 36:
                    [data36 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 37:
                    [data37 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 38:
                    [data38 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 39:
                    [data39 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 40:
                    [data40 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 41:
                    [data41 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 42:
                    [data42 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 43:
                    [data43 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 44:
                    [data44 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 45:
                    [data45 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 46:
                    [data46 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 47:
                    [data47 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 48:
                    [data48 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 49:
                    [data49 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 50:
                    [data50 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 51:
                    [data51 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 52:
                    [data52 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 53:
                    [data53 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 54:
                    [data54 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 55:
                    [data55 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 56:
                    [data56 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                
                
                default:
                    
                    break;
            }
            
        }
        
    }
    
    for (int i=0; i<chipNumb; i++) {
        NSString *fdata = @"data/UnitChip/UCdata";
        
        fdata = [fdata stringByAppendingFormat:@"%d.txt", i+1];
        
        fileData = [NSString stringWithContentsOfFile:fdata encoding:NSUTF8StringEncoding error:nil];
        fileDataArray = [fileData componentsSeparatedByString:@"\n"];
        
        UC[i].name = [[fileDataArray objectAtIndex:0] retain];
        UC[i].nameNick = [[fileDataArray objectAtIndex:1] retain];
        UC[i].nameClass = [[fileDataArray objectAtIndex:2] retain];
        
        NSArray *items = [[fileDataArray objectAtIndex:3] componentsSeparatedByString:@","];
        
        UC[i].nameRecognition = [[fileDataArray objectAtIndex:0] retain];
        UC[i].nameID = [[fileDataArray objectAtIndex:1] retain];
        
        items = [[fileDataArray objectAtIndex:4] componentsSeparatedByString:@","];
        
        UC[i].HP = [[items objectAtIndex:0] intValue];
        UC[i].MP = [[items objectAtIndex:1] intValue];
        UC[i].AP = [[items objectAtIndex:2] intValue];
        UC[i].WT = [[items objectAtIndex:3] intValue];
        UC[i].BP = [[items objectAtIndex:4] intValue];
        
        items = [[fileDataArray objectAtIndex:5] componentsSeparatedByString:@","];
        
        UC[i].STR = [[items objectAtIndex:0] intValue];
        UC[i].VIT = [[items objectAtIndex:1] intValue];
        UC[i].AGI = [[items objectAtIndex:2] intValue];
        UC[i].DEX = [[items objectAtIndex:3] intValue];
        UC[i].MEN = [[items objectAtIndex:4] intValue];
        UC[i].INT = [[items objectAtIndex:5] intValue];
        UC[i].LUK = [[items objectAtIndex:6] intValue];
        UC[i].MOV = [[items objectAtIndex:7] intValue];

        items = [[fileDataArray objectAtIndex:6] componentsSeparatedByString:@","];
        
        UC[i].MEL = [[items objectAtIndex:0] intValue];
        UC[i].MIS = [[items objectAtIndex:1] intValue];
        UC[i].HIT = [[items objectAtIndex:2] intValue];
        UC[i].DOD = [[items objectAtIndex:3] intValue];
        UC[i].REA = [[items objectAtIndex:4] intValue];
        UC[i].SKI = [[items objectAtIndex:5] intValue];
        
        items = [[fileDataArray objectAtIndex:7] componentsSeparatedByString:@","];
        
        UC[i].ATK = [[items objectAtIndex:0] intValue];
        UC[i].DEF = [[items objectAtIndex:1] intValue];
        UC[i].CAP = [[items objectAtIndex:2] intValue];
        UC[i].ACU = [[items objectAtIndex:3] intValue];
        UC[i].EVA = [[items objectAtIndex:4] intValue];
        
        items = [[fileDataArray objectAtIndex:8] componentsSeparatedByString:@","];
        
        UC[i].typeMONS = [[items objectAtIndex:0] intValue];
        UC[i].typeMOVE = [[items objectAtIndex:1] intValue];
        UC[i].cSupply = [[items objectAtIndex:2] intValue];
        UC[i].cFood = [[items objectAtIndex:3] intValue];
        UC[i].cMoney = [[items objectAtIndex:4] intValue];
        
        items = [[fileDataArray objectAtIndex:9] componentsSeparatedByString:@","];
        
        UC[i].iName = [[items objectAtIndex:0] retain];
        //NSLog(@"%@", UC[i].iName);
        UC[i].iNameb = [[items objectAtIndex:1] retain];
        
        NSString *imgName = @"uc";
        imgName = [imgName stringByAppendingFormat:@"%d", i+1];
        UC[i].img = [NSImage imageNamed:imgName];
        
        imgName = [NSString stringWithFormat:@"ucb"];
        imgName = [imgName stringByAppendingFormat:@"%d", i+1];
        UC[i].imgb = [NSImage imageNamed:imgName];
        
        NSString *imagePath = @"data/UnitChip/img/";
        imagePath = [imagePath stringByAppendingString:UC[i].iName];
        NSData *imgData = [NSData dataWithContentsOfFile:imagePath];
        
        if(imgData)
            UC[i].img = [[NSImage alloc] initWithData:[[NSFileHandle fileHandleForReadingAtPath:imagePath] readDataToEndOfFile]];
        
        imagePath = [NSString stringWithFormat:@"data/UnitChip/img/"];
        imagePath = [imagePath stringByAppendingString:UC[i].iName];
        imgData = [NSData dataWithContentsOfFile:imagePath];
        
        if(imgData)
            UC[i].imgb = [[NSImage alloc] initWithData:[[NSFileHandle fileHandleForReadingAtPath:imagePath] readDataToEndOfFile]];

    }
    
    
    
    
    InitialFlag = true;
}

-(void)saveData{
    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    char *cwd;
    cwd = getcwd(NULL, 0);
    
    
    
    for (int i=0; i<chipNumb; i++) {
        NSString *fdata = @"data/UnitChip/UCdata";
        fdata = [fdata stringByAppendingFormat:@"%d.txt", i+1];
        
        NSString *fileData = @"";
        
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].name]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].nameNick]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].nameClass]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].nameRecognition]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].nameID]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].HP]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].MP]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].AP]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].WT]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].BP]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].STR]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].VIT]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].AGI]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].DEX]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].MEN]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].INT]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].LUK]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].MOV]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].MEL]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].MIS]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].HIT]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].DOD]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].REA]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].SKI]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].ATK]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].DEF]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].CAP]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].ACU]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%g", UC[i].EVA]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].typeMONS]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].typeMOVE]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].cSupply]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].cFood]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%d", UC[i].cMoney]] stringByAppendingString:@"\n"];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].iName]] stringByAppendingString:@","];
        fileData = [[fileData stringByAppendingString:[NSString stringWithFormat:@"%@", UC[i].iNameb]] stringByAppendingString:@"\n"];
        
        fileData = [fileData stringByAppendingString:[NSString stringWithFormat:@"----\n----\n----\n"]];
        
        [fileData writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
    }
    
    
}

-(void)initFileDirectoryItem{
    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    char *cwd;
    cwd = getcwd(NULL, 0);
    
    
    NSData *InitialData = [NSData dataWithContentsOfFile:@"data/ItemList/preset.txt"];
    NSString *pathILI = @"data/ItemList/img";
    NSString *pathDATA2 = @"data/ItemList/preset.txt";
    NSString *pathIL = @"data/ItemList/preset.txt";
    NSString *fileData = nil;
    
    itemNumb = 3;
    if(!InitialData){
        [[NSFileManager defaultManager] createDirectoryAtPath:pathILI withIntermediateDirectories:YES attributes:nil error:nil];
        [[NSFileManager defaultManager] createFileAtPath:pathDATA2 contents:nil attributes:nil];
        
        [[NSFileManager defaultManager] createFileAtPath:pathIL contents:nil attributes:nil];
        
        NSString *data1 = @"鉄の剣\n鉄の剣\neq1\n1000,30,2\n0,0,0,0,0\n32,0,0,0,0,0,0\n2,0,0,0,0,0,0\n0,0,0,0\n0,0,0,0,0,0,0,0,0,0,0,0\n0,0,0,0,0,0,0,0,0,0\n鉄で出来た剣\n----\n";
        NSString *data2 = @"鋼の剣\n鋼の剣\neq2\n1500,35,2\n0,0,0,0,0\n50,0,0,0,0,0,0\n2,0,0,0,0,0,0\n0,0,0,0\n0,0,0,0,0,0,0,0,0,0,0,0\n0,0,0,0,0,0,0,0,0,0\n鋼で出来た剣\n----\n";
        NSString *data3 = @"銀の剣\n銀の剣\neq3\n2000,40,2\n0,0,0,0,0\n90,0,0,0,0,0,0\n2,0,0,0,0,0,0\n0,0,0,0\n0,0,0,0,0,0,0,0,0,0,0,0\n0,0,0,0,0,0,0,0,0,0\n銀で出来た剣\n----\n";
        
        for (int i=1; i<=itemNumb; i++) {
            NSString *fdata = @"data/ItemList/ILdata";
            
            fdata = [fdata stringByAppendingFormat:@"%d.txt", i];
            
            switch (i) {
                case 1:
                    [data1 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 2:
                    [data2 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 3:
                    [data3 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                default:
                    
                    break;
            }
            
        }
        
    }
    
    for (int i=0; i< itemNumb; i++) {
        NSString *fdata = @"data/ItemList/ILdata";
        
        fdata = [fdata stringByAppendingFormat:@"%d.txt", i+1];
        
        fileData = [NSString stringWithContentsOfFile:fdata encoding:NSUTF8StringEncoding error:nil];
        fileDataArray = [fileData componentsSeparatedByString:@"\n"];
        
        EQ[i].name = [[fileDataArray objectAtIndex:0] retain];
        EQ[i].nameRecognition = [[fileDataArray objectAtIndex:1] retain];
        EQ[i].nameID = [[fileDataArray objectAtIndex:2] retain];
        
        NSArray *items = [[fileDataArray objectAtIndex:3] componentsSeparatedByString:@","];
        
        EQ[i].price = [[items objectAtIndex:0] intValue];
        EQ[i].Weight = [[items objectAtIndex:1] intValue];
        EQ[i].type = [[items objectAtIndex:2] intValue];
        
        items = [[fileDataArray objectAtIndex:4] componentsSeparatedByString:@","];
        
        EQ[i].HP = [[items objectAtIndex:0] intValue];
        EQ[i].MP = [[items objectAtIndex:1] intValue];
        EQ[i].AP = [[items objectAtIndex:2] intValue];
        EQ[i].WT = [[items objectAtIndex:3] intValue];
        EQ[i].MOV = [[items objectAtIndex:4] intValue];
        
        items = [[fileDataArray objectAtIndex:5] componentsSeparatedByString:@","];
        
        EQ[i].STR = [[items objectAtIndex:0] intValue];
        EQ[i].VIT = [[items objectAtIndex:1] intValue];
        EQ[i].AGI = [[items objectAtIndex:2] intValue];
        EQ[i].DEX = [[items objectAtIndex:3] intValue];
        EQ[i].MEN = [[items objectAtIndex:4] intValue];
        EQ[i].INT = [[items objectAtIndex:5] intValue];
        EQ[i].LUK = [[items objectAtIndex:6] intValue];
        
        items = [[fileDataArray objectAtIndex:6] componentsSeparatedByString:@","];
        
        EQ[i].pSTR = [[items objectAtIndex:0] intValue];
        EQ[i].pVIT = [[items objectAtIndex:1] intValue];
        EQ[i].pAGI = [[items objectAtIndex:2] intValue];
        EQ[i].pDEX = [[items objectAtIndex:3] intValue];
        EQ[i].pMEN = [[items objectAtIndex:4] intValue];
        EQ[i].pINT = [[items objectAtIndex:5] intValue];
        EQ[i].pLUK = [[items objectAtIndex:6] intValue];
        
        items = [[fileDataArray objectAtIndex:7] componentsSeparatedByString:@","];
        
        EQ[i].recHP = [[items objectAtIndex:0] intValue];
        EQ[i].recpHP = [[items objectAtIndex:1] intValue];
        EQ[i].recMP = [[items objectAtIndex:2] intValue];
        EQ[i].recpMP = [[items objectAtIndex:3] intValue];
        
        items = [[fileDataArray objectAtIndex:8] componentsSeparatedByString:@","];
        
        EQ[i].R.blow = [[items objectAtIndex:0] intValue];
        EQ[i].R.slash = [[items objectAtIndex:1] intValue];
        EQ[i].R.stub = [[items objectAtIndex:2] intValue];
        EQ[i].R.arrow = [[items objectAtIndex:3] intValue];
        EQ[i].R.gun = [[items objectAtIndex:4] intValue];
        EQ[i].R.shell = [[items objectAtIndex:5] intValue];
        EQ[i].R.paralysis = [[items objectAtIndex:6] intValue];
        EQ[i].R.poison = [[items objectAtIndex:7] intValue];
        EQ[i].R.charm = [[items objectAtIndex:8] intValue];
        EQ[i].R.confusion = [[items objectAtIndex:9] intValue];
        EQ[i].R.sleep = [[items objectAtIndex:10] intValue];
        EQ[i].R.silent = [[items objectAtIndex:11] intValue];
        
        items = [[fileDataArray objectAtIndex:9] componentsSeparatedByString:@","];
        
        EQ[i].R.flame = [[items objectAtIndex:0] intValue];
        EQ[i].R.cold = [[items objectAtIndex:1] intValue];
        EQ[i].R.electoric = [[items objectAtIndex:2] intValue];
        EQ[i].R.air = [[items objectAtIndex:3] intValue];
        EQ[i].R.water = [[items objectAtIndex:4] intValue];
        EQ[i].R.gas = [[items objectAtIndex:5] intValue];
        EQ[i].R.holy = [[items objectAtIndex:6] intValue];
        EQ[i].R.dark = [[items objectAtIndex:7] intValue];
        EQ[i].R.explosion = [[items objectAtIndex:8] intValue];
        EQ[i].R.blood = [[items objectAtIndex:9] intValue];
        
        EQ[i].comment = [[fileDataArray objectAtIndex:10] retain];
    }
    
    
    
}


-(void)initFileDirectoryAttack{
    NSString *directoryPath;
    
    directoryPath = [[[NSBundle mainBundle] bundlePath] stringByDeletingLastPathComponent];
    [[NSFileManager defaultManager] changeCurrentDirectoryPath:directoryPath];
    
    char *cwd;
    cwd = getcwd(NULL, 0);
    
    
    NSData *InitialData = [NSData dataWithContentsOfFile:@"data/AttackList/preset.txt"];
    NSString *pathALI = @"data/AttackList/img";
    NSString *pathDATA2 = @"data/AttackList/preset.txt";
    NSString *pathAL = @"data/AttackList/preset.txt";
    NSString *fileData = nil;
    
    itemNumb = 2;
    if(!InitialData){
        [[NSFileManager defaultManager] createDirectoryAtPath:pathALI withIntermediateDirectories:YES attributes:nil error:nil];
        [[NSFileManager defaultManager] createFileAtPath:pathDATA2 contents:nil attributes:nil];
        
        [[NSFileManager defaultManager] createFileAtPath:pathAL contents:nil attributes:nil];
        
        NSString *data1 = @"斬りつける\n1,0,1,1\n1,1,0,0,3,100,0,25\n0,0,0,0,0,0\n0,0,0,0,0\nA\n####\n$subjの攻撃！\n$objeは舞踊った！\n----\n####\n0,30,0\n0,0,0,0,0,0\n----\n####\n0,0\n--------\n防御\n1,0,1,1\n1,1,0,0,3,100,0,30\n0,0,0,0,0,0\n0,0,0,0,0\nA\n####\n$subjの防御！\n$objeは様子を見ている！\n----\n####\n1,30,0\n0,0,0,0,0,0\n----\n####\n0,0";
        NSString *data2 = @"叩き付ける\n1,0,1,1\n1,1,0,0,3,100,0,45\n0,0,0,0,0,0\n0,0,0,0,0\nA\n####\n$subjの攻撃！\n$objeは舞踊った！\n----\n####\n0,30,0\n0,0,0,0,0,0\n----\n####\n0,0\n--------\n防御\n1,0,1,1\n1,1,0,0,3,100,0,45\n0,0,0,0,0,0\n0,0,0,0,0\nA\n####\n$subjの防御！\n$objeは様子を見ている！\n----\n####\n1,30,0\n0,0,0,0,0,0\n----\n####\n0,0";
        
        for (int i=1; i<=itemNumb; i++) {
            NSString *fdata = @"data/AttackList/ALdata";
            
            fdata = [fdata stringByAppendingFormat:@"%d.txt", i];
            
            switch (i) {
                case 1:
                    [data1 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                case 2:
                    [data2 writeToFile:fdata atomically:YES encoding:NSUTF8StringEncoding error:nil];
                    break;
                default:
                    
                    break;
            }
            
        }
        
    }
    
    NSArray *fileDataArray2;
    ATTACK *Atop;
    
    for (int i=0; i< itemNumb; i++) {
        NSString *fdata = @"data/AttackList/ALdata";
        
        fdata = [fdata stringByAppendingFormat:@"%d.txt", i+1];
        
        fileData = [NSString stringWithContentsOfFile:fdata encoding:NSUTF8StringEncoding error:nil];
        fileDataArray2 = [fileData componentsSeparatedByString:@"--------\n"];
        
        bool initAttackAdd = false;
        [self AddATTACK:&UC[i].A :0];
        
        for(int j=0;j < [fileDataArray2 count];j++){UC[i].attackListNum++;
        fileDataArray = [[fileDataArray2 objectAtIndex:j] componentsSeparatedByString:@"\n"];
            
        [self AddATTACK:&UC[i].A :j];
            
        if(!initAttackAdd) Atop = UC[i].A;
            initAttackAdd = true;
            
        UC[i].A->name = [[fileDataArray objectAtIndex:0] retain];
        
        NSArray *items = [[fileDataArray objectAtIndex:1] componentsSeparatedByString:@","];
        
        UC[i].A->trig = [[items objectAtIndex:0] intValue];
        UC[i].A->type = [[items objectAtIndex:1] intValue];
        UC[i].A->melee = [[items objectAtIndex:2] intValue];
        UC[i].A->P = [[items objectAtIndex:3] intValue];
        
        items = [[fileDataArray objectAtIndex:2] componentsSeparatedByString:@","];
        
        UC[i].A->rangeA = [[items objectAtIndex:0] intValue];
        UC[i].A->rangeB = [[items objectAtIndex:1] intValue];
        UC[i].A->extent = [[items objectAtIndex:2] intValue];
        UC[i].A->bullet = [[items objectAtIndex:3] intValue];
        UC[i].A->hitCount = [[items objectAtIndex:4] intValue];
        UC[i].A->successRate = [[items objectAtIndex:5] intValue];
        UC[i].A->vigor = [[items objectAtIndex:6] intValue];
        UC[i].A->hitPercent = [[items objectAtIndex:7] intValue];
        
        items = [[fileDataArray objectAtIndex:3] componentsSeparatedByString:@","];
        
        UC[i].A->costType = [[items objectAtIndex:0] intValue];
        
        if(UC[i].A->costType == 0) {
            UC[i].A->MP = [[items objectAtIndex:1] intValue];
            UC[i].A->pMP = [[items objectAtIndex:2] intValue];
        }
        else if(UC[i].A->costType == 1) {
            UC[i].A->AP = [[items objectAtIndex:1] intValue];
            UC[i].A->pAP = [[items objectAtIndex:2] intValue];
        }
        else if(UC[i].A->costType == 2) {
            UC[i].A->HP = [[items objectAtIndex:1] intValue];
            UC[i].A->pHP = [[items objectAtIndex:2] intValue];
        }
        
        UC[i].A->cSupply = [[items objectAtIndex:3] intValue];
        UC[i].A->cFood = [[items objectAtIndex:4] intValue];
        UC[i].A->cMoney = [[items objectAtIndex:5] intValue];

        items = [[fileDataArray objectAtIndex:4] componentsSeparatedByString:@","];
        
        UC[i].A->riku = [[items objectAtIndex:0] intValue];
        UC[i].A->chu = [[items objectAtIndex:1] intValue];
        UC[i].A->umi = [[items objectAtIndex:2] intValue];
        UC[i].A->sora = [[items objectAtIndex:3] intValue];
        UC[i].A->dmgExtend = [[items objectAtIndex:4] intValue];
        
        UC[i].A->cmd = [[fileDataArray objectAtIndex:5] retain];
        UC[i].A->msg = @"";
        
        [self AddDAMAGE:&UC[i].A->D :0];
        [self AddDMGEXTEND:&UC[i].A->E :0];
        
        DAMAGE *Dtop = UC[i].A->D;
        DMGEXTEND *Etop = UC[i].A->E;
        
        int stringType = 0;
        int stringRange = 1;
        int stringNumber = 0;
        for (int k = 6; k<[fileDataArray count];k++) {
            NSString *str = [fileDataArray objectAtIndex:k];
            NSRange rangeSearch, rangeSearch2;
            NSArray *rangeArray;
            rangeSearch = [str rangeOfString:@"####"];
            rangeArray = [str componentsSeparatedByString:@","];
            rangeSearch2 = [str rangeOfString:@"----"];
            if(stringType == 0)
            if (rangeSearch.location != NSNotFound) {
                
            }else if(rangeSearch2.location != NSNotFound){
                stringType = 1;
            }else{
                if(UC[i].A->msg == NULL){
                    UC[i].A->msg = [str retain];
                }else{
                    UC[i].A->msg = [UC[i].A->msg stringByAppendingFormat:@"%@", str];
                }
            }else if(stringType == 1){stringRange ++;
                if(rangeSearch2.location != NSNotFound){
                    stringType = 2;
                }
                else if(rangeSearch.location != NSNotFound){
                    stringRange = 0;
                }else if(stringRange == 1){
                    UC[i].A->D->type = [[rangeArray objectAtIndex:0] intValue];
                    UC[i].A->D->count = [[rangeArray objectAtIndex:1] intValue];
                    UC[i].A->D->pCount = [[rangeArray objectAtIndex:2] intValue];
                }else if(stringRange == 2){
                    UC[i].A->D->seed = [[rangeArray objectAtIndex:0] intValue];
                    UC[i].A->D->sort = [[rangeArray objectAtIndex:1] intValue];
                    UC[i].A->D->continium = [[rangeArray objectAtIndex:2] intValue];
                    UC[i].A->D->absolute = [[rangeArray objectAtIndex:3] intValue];
                    UC[i].A->D->beam = [[rangeArray objectAtIndex:4] intValue];
                    UC[i].A->D->noSizeFix = [[rangeArray objectAtIndex:5] intValue];
                    
                    stringNumber++;
                    [self AddDAMAGE:&UC[i].A->D :stringNumber];
                    UC[i].A->D = UC[i].A->D->next;
                }
            }else if(stringType == 2){stringRange ++;
                if(rangeSearch.location != NSNotFound){
                    stringRange = 0;
                    stringNumber = 0;
                }else if(stringRange == 1){
                    UC[i].A->E->rate = [[rangeArray objectAtIndex:0] intValue];
                    UC[i].A->E->hit = [[rangeArray objectAtIndex:1] intValue];
                    
                    stringNumber++;
                    [self AddDMGEXTEND:&UC[i].A->E :stringNumber];
                    UC[i].A->E = UC[i].A->E->next;
                }
            
            }
        }
            UC[i].A->D = Dtop;
            UC[i].A->E = Etop;
            
            UC[i].A = UC[i].A->next;
        }
        UC[i].A = Atop;
    }
    
    
    
    
}

-(ATTACK*)AllocATTACK{
    return (calloc(1, sizeof(ATTACK)));
}
-(DAMAGE*)AllocDAMAGE{
    return (calloc(1, sizeof(DAMAGE)));
}
-(DMGEXTEND*)AllocDMGEXTEND{
    return (calloc(1, sizeof(DMGEXTEND)));
}

-(void)AddATTACK:(ATTACK**)top:(int)no{
    ATTACK *ptr = *top;
    if(*top == NULL){
        *top = [self AllocATTACK];
        ptr = *top;
        ptr->index = no;
        ptr->next = NULL;
    }else{
        while(ptr->next != NULL) ptr = ptr->next;
        ptr->next = [self AllocATTACK];
        ptr->index = no;
        ptr->next->next = NULL;
        
    }
    
    
}

-(void)AddDAMAGE:(DAMAGE**)top:(int)no{
    DAMAGE *ptr = *top;
    if(*top == NULL){
        *top = [self AllocDAMAGE];
        ptr = *top;
        ptr->index = no;
    }else{
        while(ptr->next != NULL) ptr = ptr->next;
        ptr->next = [self AllocDAMAGE];
        ptr->index = no;
        ptr->next->next = NULL;
        
    }
    
    
}

-(void)AddDMGEXTEND:(DMGEXTEND**)top:(int)no{
    DMGEXTEND *ptr = *top;
    if(*top == NULL){
        *top = [self AllocDMGEXTEND];
        ptr = *top;
        ptr->index = no;
    }else{
        while(ptr->next != NULL) ptr = ptr->next;
        ptr->next = [self AllocDMGEXTEND];
        ptr->index = no;
        ptr->next->next = NULL;
        
    }
    
    
}



-(void)initItemList{
    equipListMA = [NSMutableArray new];
    
    for(int i = 0;i < itemNumb;i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        NSString *str = @"";
        [dict setValue:[NSString stringWithFormat:@"%@", EQ[i].name] forKey:@"name"];
        
        if(EQ[i].HP != 0)
            str = [str stringByAppendingFormat:@"HP %d ", (int)EQ[i].HP];
        if(EQ[i].MP != 0)
            str = [str stringByAppendingFormat:@"MP %d ", (int)EQ[i].MP];
        if(EQ[i].STR != 0) 
            str = [str stringByAppendingFormat:@"STR %d ", (int)EQ[i].STR];
        if(EQ[i].VIT != 0)
            str = [str stringByAppendingFormat:@"VIT %d ", (int)EQ[i].VIT];
        if(EQ[i].AGI != 0)
            str = [str stringByAppendingFormat:@"AGI %d ", (int)EQ[i].AGI];
        if(EQ[i].DEX != 0)
            str = [str stringByAppendingFormat:@"DEX %d ", (int)EQ[i].DEX];
        if(EQ[i].MEN != 0)
            str = [str stringByAppendingFormat:@"MEN %d ", (int)EQ[i].MEN];
        if(EQ[i].INT != 0)
            str = [str stringByAppendingFormat:@"INT %d ", (int)EQ[i].INT];
        if(EQ[i].LUK != 0)
            str = [str stringByAppendingFormat:@"LUK %d ", (int)EQ[i].LUK];
        if(EQ[i].Weight != 0)
            str = [str stringByAppendingFormat:@"重さ %d ", (int)EQ[i].Weight];
        
        [dict setValue:[NSString stringWithFormat:@"%@", str] forKey:@"memo"];
        
        [self willChangeValueForKey:@"equipListMA"];
        [equipListMA addObject:dict];
        [self didChangeValueForKey:@"equipListMA"];
    }
    
    
}


-(void)initUnitChipList{
    unitChipListMA = [NSMutableArray new];
    
    for(int i = 0;i < chipNumb;i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        
        
        [dict setValue:UC[i].img forKey:@"img"];
        [dict setValue:UC[i].imgb forKey:@"imgBig"];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[i].name] forKey:@"name"];
        [dict setValue:[NSString stringWithFormat:@"%g", UC[i].HP] forKey:@"HP"];
        [dict setValue:[NSString stringWithFormat:@"%g", UC[i].BP] forKey:@"BP"];
        [dict setValue:[NSString stringWithFormat:@"%@", UC[i].nameClass] forKey:@"nameC"];
        [self willChangeValueForKey:@"unitChipListMA"];
        [unitChipListMA addObject:dict];
        [self didChangeValueForKey:@"unitChipListMA"];
    }
    
    
}

-(void)initAttackList{
    attackListMA = [NSMutableArray new];
    
    [self willChangeValueForKey:@"attackListMA"];
    [attackListMA removeAllObjects];
    [self didChangeValueForKey:@"attackListMA"];
    
    ATTACK *Atop = UC[clickIndex].A;
    
    for(int i = 0;i < UC[clickIndex].attackListNum;i++){
        NSMutableDictionary* dict = [NSMutableDictionary new];
        
        NSString *str;
        if(UC[clickIndex].A->D->type == 0) str = [NSString stringWithFormat:@"攻"];
        if(UC[clickIndex].A->D->type == 1) str = [NSString stringWithFormat:@"防"];
        if(UC[clickIndex].A->D->type == 2) str = [NSString stringWithFormat:@"命"];
        if(UC[clickIndex].A->D->type == 3) str = [NSString stringWithFormat:@"回"];
        if(UC[clickIndex].A->D->type == 4) str = [NSString stringWithFormat:@"演"];
        if(UC[clickIndex].A->D->type == 5) str = [NSString stringWithFormat:@"会"];
        
        str = [str stringByAppendingFormat:@"%g", UC[clickIndex].A->D->count];
        [dict setValue:[NSString stringWithFormat:@"%@", str] forKey:@"atk"];
        
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].A->name] forKey:@"name"];
        [dict setValue:[NSString stringWithFormat:@"%d", UC[clickIndex].A->hitPercent] forKey:@"hit"];
        [dict setValue:[NSString stringWithFormat:@"%d", UC[clickIndex].A->vigor] forKey:@"vigor"];
        [dict setValue:[NSString stringWithFormat:@"%d", UC[clickIndex].A->bullet] forKey:@"bullet"];
        if(UC[clickIndex].A->rangeA == UC[clickIndex].A->rangeB)
            [dict setValue:[NSString stringWithFormat:@"%d", UC[clickIndex].A->rangeA] forKey:@"range"];
        else
             [dict setValue:[NSString stringWithFormat:@"%d-%d", UC[clickIndex].A->rangeA, UC[clickIndex].A->rangeB] forKey:@"range"];
        
        if(UC[clickIndex].A->MP > 0)
        [dict setValue:[NSString stringWithFormat:@"MP%g", UC[clickIndex].A->MP] forKey:@"cost"];
        else if(UC[clickIndex].A->AP > 0)
        [dict setValue:[NSString stringWithFormat:@"AP%g", UC[clickIndex].A->AP] forKey:@"cost"];
        else if(UC[clickIndex].A->HP > 0)
        [dict setValue:[NSString stringWithFormat:@"HP%g", UC[clickIndex].A->HP] forKey:@"cost"];
        
        [dict setValue:[NSString stringWithFormat:@"%@", UC[clickIndex].A->cmd] forKey:@"command"];
        
        [dict setValue:[NSString stringWithFormat:@"%d", UC[clickIndex].A->D->type] forKey:@"type"];
        
        
        [self willChangeValueForKey:@"attackListMA"];
        [attackListMA addObject:dict];
        [self didChangeValueForKey:@"attackListMA"];
        
        UC[clickIndex].A = UC[clickIndex].A->next;
    }
    
    UC[clickIndex].A = Atop;
}

-(IBAction)skillListBtnUCL:(id)sender{
    windowPoint.x = [UCLDetailPanel frame].origin.x + 40;
    windowPoint.y = [UCLDetailPanel frame].origin.y + 80;
    [UCLPanelSkill setFrameOrigin:windowPoint];
    [UCLPanelSkill makeKeyAndOrderFront:nil];
}

-(IBAction)attackListBtnlUCL:(id)sender{
    [self initAttackList];
    
    windowPoint.x = [UCLDetailPanel frame].origin.x;
    windowPoint.y = [UCLDetailPanel frame].origin.y + 50;
    [UCLPanelAttack setFrameOrigin:windowPoint];
    [UCLPanelAttack makeKeyAndOrderFront:nil];
}

-(IBAction)registListBtnlUCL:(id)sender{
    windowPoint.x = [UCLDetailPanel frame].origin.x + 150;
    windowPoint.y = [UCLDetailPanel frame].origin.y;
    [UCLPanelRegist setFrameOrigin:windowPoint];
    [UCLPanelRegist makeKeyAndOrderFront:nil];
}


-(IBAction)skillListBtnSubmitUCL:(id)sender{
    [UCLPanelSkill close];
}
-(IBAction)attackListBtnSubmitlUCL:(id)sender{
    [UCLPanelAttack close];
}
-(IBAction)registListBtnlSubmitUCL:(id)sender{
    [UCLPanelRegist close];
}

-(IBAction)insertSkillUCL:(id)sender{

}
-(IBAction)removeSkillUCL:(id)sender{

}

-(IBAction)mobileUCL:(id)sender{

}
-(IBAction)skillUCL:(id)sender{

}
-(IBAction)equiplUCL:(id)sender{

}


-(IBAction)UCLPanelEquipListSubmitBtn:(id)sender{
    [UCLPanelEquipList close];
}
-(IBAction)UCLPanelSkillListSubmitBtn:(id)sender{
    [UCLPanelSkillList close];
}

-(IBAction)UCLPanelEquipListOpenBtn:(id)sender{
    windowPoint.x = [UCLPanel frame].origin.x + 50;
    windowPoint.y = [UCLPanel frame].origin.y;
    [UCLPanelEquipList setFrameOrigin:windowPoint];
    [UCLPanelEquipList makeKeyAndOrderFront:nil];
}
-(IBAction)UCLPanelSkillListOpenBtn:(id)sender{
    windowPoint.x = [UCLPanel frame].origin.x + 50;
    windowPoint.y = [UCLPanel frame].origin.y;
    [UCLPanelSkillList setFrameOrigin:windowPoint];
    [UCLPanelSkillList makeKeyAndOrderFront:nil];
}

-(IBAction)insertAttackList:(id)sender{
    NSMutableDictionary* dict = [NSMutableDictionary new];
    [dict setValue:[NSString stringWithFormat:@"新技"] forKey:@"name"];
    [self willChangeValueForKey:@"attackListMA"];
    [attackListMA insertObject:dict atIndex:[attackListTV selectedRow]+1];
    [self didChangeValueForKey:@"attackListMA"];
    
    ATTACK *Atop = UC[clickIndex].A;
    
    while(UC[clickIndex].A->next != NULL) UC[clickIndex].A = UC[clickIndex].A->next;
    [self AddATTACK:&UC[clickIndex].A :UC[clickIndex].A->index+1];
    UC[clickIndex].A->name = [@"新技" retain];
    UC[clickIndex].A = Atop;
    
}
-(IBAction)removeAttackList:(id)sender{
    
    if([attackListTV selectedRow] >= 0){
        [self willChangeValueForKey:@"attackListMA"];
        [attackListMA removeObjectAtIndex:[attackListTV selectedRow]];
        [self didChangeValueForKey:@"attackListMA"];
    }
    
}
-(IBAction)insertComboList:(id)sender{

}
-(IBAction)removeComboList:(id)sender{
    
}

-(IBAction)submitAttackList:(id)sender{
    [UCLPanelAttackDetail close];
}

-(IBAction)insertDamageList:(id)sender{
    NSMutableDictionary* dict = [NSMutableDictionary new];
    
    if([ALPUBtype indexOfSelectedItem] == 0)
        [dict setValue:[NSString stringWithFormat:@"攻%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    if([ALPUBtype indexOfSelectedItem] == 1)
        [dict setValue:[NSString stringWithFormat:@"防%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    if([ALPUBtype indexOfSelectedItem] == 2)
        [dict setValue:[NSString stringWithFormat:@"命%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    if([ALPUBtype indexOfSelectedItem] == 3)
        [dict setValue:[NSString stringWithFormat:@"回%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    if([ALPUBtype indexOfSelectedItem] == 4)
        [dict setValue:[NSString stringWithFormat:@"演%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    if([ALPUBtype indexOfSelectedItem] == 5)
        [dict setValue:[NSString stringWithFormat:@"会%d+%d％", [ALTFdmgCount intValue], [ALTFdmgRate intValue]] forKey:@"count"];
    
    NSString *str;
    
    if([ALPUBsort indexOfSelectedItem] == 0) str = [NSString stringWithFormat:@"ダ・"];
    if([ALPUBsort indexOfSelectedItem] == 1) str = [NSString stringWithFormat:@"回・"];
    if([ALPUBsort indexOfSelectedItem] == 2) str = [NSString stringWithFormat:@"復・"];
    if([ALPUBsort indexOfSelectedItem] == 3) str = [NSString stringWithFormat:@"減・"];
    if([ALPUBsort indexOfSelectedItem] == 4) str = [NSString stringWithFormat:@"増・"];
    if([ALPUBsort indexOfSelectedItem] == 5) str = [NSString stringWithFormat:@"毒・"];
    if([ALPUBsort indexOfSelectedItem] == 6) str = [NSString stringWithFormat:@"睡・"];
    if([ALPUBsort indexOfSelectedItem] == 7) str = [NSString stringWithFormat:@"混・"];
    if([ALPUBsort indexOfSelectedItem] == 8) str = [NSString stringWithFormat:@"麻・"];
    if([ALPUBsort indexOfSelectedItem] == 9) str = [NSString stringWithFormat:@"沈・"];
    if([ALPUBsort indexOfSelectedItem] == 10) str = [NSString stringWithFormat:@"魅・"];
    
    if([ALPUBseed indexOfSelectedItem] == 0) str = [str stringByAppendingFormat:@"打撃"];
    if([ALPUBseed indexOfSelectedItem] == 1) str = [str stringByAppendingFormat:@"斬撃"];
    if([ALPUBseed indexOfSelectedItem] == 2) str = [str stringByAppendingFormat:@"突き"];
    if([ALPUBseed indexOfSelectedItem] == 3) str = [str stringByAppendingFormat:@"射手"];
    if([ALPUBseed indexOfSelectedItem] == 4) str = [str stringByAppendingFormat:@"銃撃"];
    if([ALPUBseed indexOfSelectedItem] == 5) str = [str stringByAppendingFormat:@"砲撃"];
    if([ALPUBseed indexOfSelectedItem] == 6) str = [str stringByAppendingFormat:@"火炎"];
    if([ALPUBseed indexOfSelectedItem] == 7) str = [str stringByAppendingFormat:@"冷気"];
    if([ALPUBseed indexOfSelectedItem] == 8) str = [str stringByAppendingFormat:@"電撃"];
    if([ALPUBseed indexOfSelectedItem] == 9) str = [str stringByAppendingFormat:@"風圧"];
    if([ALPUBseed indexOfSelectedItem] == 10) str = [str stringByAppendingFormat:@"流水"];
    if([ALPUBseed indexOfSelectedItem] == 11) str = [str stringByAppendingFormat:@"ガス"];
    if([ALPUBseed indexOfSelectedItem] == 12) str = [str stringByAppendingFormat:@"神聖"];
    if([ALPUBseed indexOfSelectedItem] == 13) str = [str stringByAppendingFormat:@"暗黒"];
    if([ALPUBseed indexOfSelectedItem] == 14) str = [str stringByAppendingFormat:@"爆撃"];
    if([ALPUBseed indexOfSelectedItem] == 15) str = [str stringByAppendingFormat:@"流血"];
    
    [dict setValue:[NSString stringWithFormat:@"%@", str] forKey:@"type"];
    [self willChangeValueForKey:@"damageListMA"];
    [damageListMA insertObject:dict atIndex:[damageListTV selectedRow]+1];
    [self didChangeValueForKey:@"damageListMA"];
    
    NSLog(@"おまんこ");
}

-(IBAction)removeDamageList:(id)sender{

    if([damageListTV selectedRow] >= 0){
        [self willChangeValueForKey:@"damageListMA"];
        [damageListMA removeObjectAtIndex:[damageListTV selectedRow]];
        [self didChangeValueForKey:@"damageListMA"];
    }
}

-(IBAction)insertHitList:(id)sender{
    NSMutableDictionary* dict = [NSMutableDictionary new];
    [dict setValue:[NSString stringWithFormat:@"%d", [ALTFrate intValue]] forKey:@"rate"];
    [dict setValue:[NSString stringWithFormat:@"%d", [ALTFhit intValue]] forKey:@"hit"];
    
    [self willChangeValueForKey:@"hitListMA"];
    [hitListMA insertObject:dict atIndex:[hitListTV selectedRow]+1];
    [self didChangeValueForKey:@"hitListMA"];
}

-(IBAction)removeHitList:(id)sender{

    if([hitListTV selectedRow] >= 0){
        [self willChangeValueForKey:@"hitListMA"];
        [hitListMA removeObjectAtIndex:[hitListTV selectedRow]];
        [self didChangeValueForKey:@"hitListMA"];
    }
}

@end
